// _] t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x400*5*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int ofs;
	int size;
};

int main(int argc, char *argv[])
{
	//	ȃf[^̈ʒu

	char fname[11];
	int musnum=0;
	int i;

	struct fpos md1[] =
	{
		{ 0x2c, 0x04, 0x0000, 0x0500 },	// Magnetic Magician
		{ 0x2d, 0x01, 0x0000, 0x1300 },	// Running Star
		{ 0x2d, 0x05, 0x0000, 0x0600 },	// A Statuette of loser
		{ 0x2e, 0x02, 0x0000, 0x0400 },	// Si-Si-Si
		{ 0x2e, 0x03, 0x0000, 0x0200 },	// Over the moon
		{ 0x00, 0x00, 0x0000, 0x0000 },	// Dummy
	};

	struct fpos md2[] =
	{
		{ 0x0b, 0x15, 0x0000, 0x0200 },	// Yumiko
		{ 0x10, 0x14, 0x0000, 0x1400 },	// Bright Morning
		{ 0x11, 0x14, 0x0000, 0x0300 },	// S[M̌C
		{ 0x12, 0x11, 0x0000, 0x0600 },	// Izanami...
		{ 0x12, 0x12, 0x0200, 0x0500 },	// Y
		{ 0x12, 0x15, 0x0000, 0x1e00 },	// Romantic Hell
		{ 0x27, 0x13, 0x0000, 0x0a00 },	// Major II
		{ 0x4f, 0x14, 0x0000, 0x0500 },	// P̒
		{ 0x00, 0x00, 0x0000, 0x0000 },	// Dummy
	};

	if (argc != 2) {
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: ddscut [d88file]\n");
		return 1;
	}

	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (int d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.ReadID(2, buff, 4);

		if (buff[0x02] < 6)
		{
			// Disk 1
			printf("Disk 1F܂.\n");
			disk.SetRecordRange(0x01,0x05);
			for (i=0; md1[i].trk; i++)
			{
				sprintf(fname,"MUS%02d",musnum++);
				fcut(fname, md1[i].trk, md1[i].trk>>1, md1[i].trk&1, md1[i].sec, 0x03, md1[i].ofs, md1[i].size);
			}
		}
		else if (buff[0x02] > 0x10)
		{
			// Disk 2
			printf("Disk 2F܂.\n");
			disk.SetRecordRange(0x11,0x15);
			for (i=0; md2[i].trk; i++)
			{
				sprintf(fname,"MUS%02d",musnum++);
				fcut(fname, md2[i].trk, md2[i].trk>>1, md2[i].trk&1, md2[i].sec, 0x03, md2[i].ofs, md2[i].size);
			}
			// hCo
			fcut("MMODE",  0x08, 0x04, 0, 0x11, 0x03, 0x0000, 0x1800);
//			fcut("OP",     0x02, 0x01, 0, 0x11, 0x03, 0x0000, 0x1400);
		}
	}
	return 0;
}

